# Change Log

## 2.0.0

Changes and additions:
- Switched job description to xRSL since ARC 6 has dropped JSDL.
- Added performance metric based on execution time for most ARC client
  command invocations.
- Added performance metric for job state transitions.
- Added facility to track success rate of random choices and adjust the
  distribution accordingly, to reduce false alerts due to dependencies on
  unreliable resources.
- Switched to setuptools for installation.
- Parallelize `arcget` invocations for `check_arcce_monitor`.
- Improved capturing and reporting of command errors.
- Set up CI testing.
- Converted to Python 3.
- Factored out dependency on `arc`, `ldap`, `lockfile`, and `ply` missing
  for Python 3 on various platforms, adding dependency on `ldap3` and
  optionally `cryptography` instead.
- Added `--max-proxy-age` option mainly to support proxy renewal without
  `cryptography`.

Fixes:
- Fixed exception in state monitoring due to misspelled attribute.
- Fixed TLS connection parameters for `check_arcservice`.
- Update `arcce_igtf.py` to support worker nodes where the default Python
  version is 3, and do not rely on $PATH as it may contain a custom version.
- Various fixes to support newer Python versions.
- Lock and atomically replace job info files.

Removed or obsolete:
- Removed the obsolete `check_arcinfosys` probe.
- Removed the `check_arcglue2` and `check_archostcert` probes in preparation
  for Python 3 conversion.  These would have otherwise been deprecated.
- The remaining probes which use the LDAP-based information system,
  `check_egiis` and `check_aris`, will soon be deprecated, but the latter is
  still needed to check the queue status of a CE.
- Removed the deprecated `--stage-input`, `--stage-output`, `--top-workdir`,
  `--plugins-spooldir` options and the deprecated default configuration
  paths.
- EL 5 or earlier is no longer supported.

## 1.9.1

Important bug fixes:
- In `check_arcce_monitor`, truncate the `--timeout` argument for `arcstat`
  to integer. The issue occurs on sufficiently high load due to a `min`
  function, but can be worked around by passing a very high value for
  `--arcget-timeout`.
- Tolerate newlines within CE properties of the `arcstat` output.
- Tolerate missing download directories if the job is in a failed state.

## 1.9.0

Important changes:
- Move scheduled cleanup from `check_arcce_monitor` to `check_arcce_clean`.
  As a consequence users may want to run `check_arcce_clean` at least once
  per every hour.
- Keep better track of the work done by `check_arcce_monitor` and
  `check_arcce_clean`. Try to bail out within a slotted time to avoid
  unclean exits and spurious Nagios alerts. Instead report on the progress
  and raise a warning or critical alerts if it seems like the probes are not
  keeping up.
- Clean up jobs from the local ARC job file which cannot be queried and
  which do not correspond to any active job.
- The operation of `check_arcce_monitor` can now be restricted to jobs for a
  certain CE and/or those having been created with a certain `--job-tag`.
  This should allow running one monitor service per CE and/or job type,
  though it has not been tested under Nagios.

Minor fixes:
- Remove execute bit and shebang from `arcce_igtf.py`.
- In `check_archostcert` consider certs unusable 2 days before expiration.
- Various timeouts have been adjusted or added.
- Fix repeated renaming of output directories from `arcget`.
- Make random adjustments to rescheduled job times and process rescheduled
  and monitoring work in random order.
- Remove deprecated `--use-jobs-xml` option from `check_arcce_clean` and
  some other ancient stuff which nobody will notice.
- Avoid warning due to unparsed 12 hex-digit lines from `arcstat`.
- Various minor fixes.

## Earlier

Earlier changes were published as annotated git tags.
